package stamp.peripheral.sensor.GPS.Include;

import stamp.peripheral.sensor.GPS.Include.*;           // Contains the GPS message list and more
import stamp.peripheral.sensor.GPS.DisplayDriver.*;     // Contains the LCD driver for the CrystalFontz

public class GPSCoordinate
{
  // The latitude
  public int m_nLatDeg;
  public int m_nLatMinute;
  public int m_nLatMinuteDec;
  public boolean m_bNorth;

  // The longitude
  public int m_nLongDeg;
  public int m_nLongMinute;
  public int m_nLongMinuteDec;
  public boolean m_bEast;

  private StringBuffer m_buffer;

  public GPSCoordinate()
  {
    m_buffer = new StringBuffer(9);
    Clear();
  };

  public void Copy( GPSCoordinate other )
  {
    // The latitude
    m_nLatDeg = other.m_nLatDeg;
    m_nLatMinute = other.m_nLatMinute;
    m_nLatMinuteDec = other.m_nLatMinuteDec;
    m_bNorth = other.m_bNorth;

    // The longitude
    m_nLongDeg = other.m_nLongDeg;
    m_nLongMinute = other.m_nLongMinute;
    m_nLongMinuteDec = other.m_nLongMinuteDec;
    m_bEast = other.m_bEast;
    m_buffer.clear();
    m_buffer.append(other.m_buffer.toString());

  }
  public void Clear()
  {
    // The latitude
    m_nLatDeg = 0;
    m_nLatMinute = 0;
    m_nLatMinuteDec = 0;
    m_bNorth = false;

    // The longitude
    m_nLongDeg = 0;
    m_nLongMinute = 0;
    m_nLongMinuteDec = 0;
    m_bEast = false;
    m_buffer.clear();
  }
  public String GetCoordinateString(){ return (m_buffer.toString()); };
  public StringBuffer GetCoordinateName() { return (m_buffer);};
  public void SetCoordinateName( String str )
  {
    m_buffer.clear();
    int n = str.length() > 8 ? 8 : str.length();
    m_buffer.append( str );
  }
  public void GetLongitude( StringBuffer buffer )
  {
    buffer.clear();
    buffer.append(m_nLongDeg);
    buffer.append((char)DisplayDriver.SPECIAL_CHARACTER_DEGREE);
    if ( m_nLongMinute < 10 )
      buffer.append("0");

    buffer.append(m_nLongMinute);
    buffer.append("'");
    int nTemp = (int)(m_nLongMinuteDec / 100);
    if ( nTemp < 10 )
      buffer.append("0");

    buffer.append(nTemp);
    buffer.append( m_bEast ? "E" : "W" );
  }
  public void GetLatitude( StringBuffer buffer )
  {
    buffer.clear();
    buffer.append(m_nLatDeg);
    buffer.append((char)DisplayDriver.SPECIAL_CHARACTER_DEGREE);

    if ( m_nLatMinute < 10 )
      buffer.append("0");

    buffer.append(m_nLatMinute);
    buffer.append("'");

    int nTemp = (int)(m_nLatMinuteDec / 100);
    if (nTemp < 10)
      buffer.append("0");

    buffer.append(nTemp);
    buffer.append( m_bNorth ? "N" : "S");
  }

}