package stamp.peripheral.sensor.GPS.Include;

import stamp.core.*;
import stamp.peripheral.memory.eeprom.*;                // Contains handling for EEPROM operations
import stamp.peripheral.sensor.GPS.GPSMath.*;           // Contains the GPS calculations
import stamp.peripheral.sensor.GPS.NMEA.*;              // Contains the NMEA messages and other NMEA specific things
import stamp.peripheral.sensor.GPS.StringOperations.*;  // Contains some string handling classes
import stamp.peripheral.sensor.GPS.Include.*;           // Contains the linked list class and other stuff
import stamp.peripheral.sensor.GPS.Keyboard.*;          // Contains the memkey implementation
import stamp.peripheral.sensor.GPS.Temperature.*;       // Contains the SHT11 sensor wrapper
import stamp.peripheral.sensor.GPS.DisplayDriver.*;     // Contains the LCD driver for the CrystalFontz
import stamp.peripheral.sensor.GPS.RouteFollower.*;     // Contains the class handling keeping track of were we are and where to go
import stamp.peripheral.sensor.GPS.Menu.*;              // Contains the GPS menu
import com.micromegacorp.math.hardware.*;               // uM-FPU
import stamp.peripheral.display.lcd.CrystalFontz.*;     // Contains the LCD layer

/**
  This class contains all the global variables used in the program.
*/

public class GlobalVars
{
  public Float32 m_fTemp1;
  public Float32 m_fTemp2;
  public Float32 m_fTemp3;
  public Float32 m_fTemp4;
  public Float32 m_fTemp5;
  public Float32 m_fTemp6;
  public Float32 m_fTemp7;
  public Float32 m_fTemp8;
  public Float32 m_fTemp9;
  public Float32 m_fTemp10;
  public Float32 m_fTemp11;
  public Float32 m_fTemp12;

  public StringBuffer m_buffer1;
  public GPSCoordinate m_gpsCoordinate1;
  public UTCTimeParser m_timeParser;


  public GlobalVars( DisplayDriver displayDriver ) throws Exception
  {

    m_timeParser = new UTCTimeParser();

    // If the uM FPU is not OK, do not continue
    //displayDriver.WriteMessage( DisplayDriver.DISPLAY_1, 1, 0, "uM-FPU...");

    if (!Fpu.reset())
    {
      //displayDriver.WriteMessage(DisplayDriver.DISPLAY_1, 1, 0, "uM-FPU not responding" );
      throw new Exception();
    }

    // Write out uM-FPU is OK!
    //displayDriver.WriteMessage(DisplayDriver.DISPLAY_1, 1, 16, "OK!" );

    // All the floats
    m_fTemp1 = new Float32();
    m_fTemp2 = new Float32();
    m_fTemp3 = new Float32();
    m_fTemp4 = new Float32();
    m_fTemp5 = new Float32();
    m_fTemp6 = new Float32();
    m_fTemp7 = new Float32();
    m_fTemp8 = new Float32();
    m_fTemp9 = new Float32();
    m_fTemp10 = new Float32();
    m_fTemp11 = new Float32();
    m_fTemp12 = new Float32();

    // The stringbuffer
    m_buffer1 = new StringBuffer( 170 ); //  Allocate 170 bytes

    m_gpsCoordinate1 = new GPSCoordinate();
  }
}