
package stamp.peripheral.sensor.GPS.Include;
import stamp.core.*;

public class UTCTimeParser
{
  public byte m_byteUTCHour = 0x00;      // Hour
  public byte m_byteUTCMinute = 0x00;    // Minute
  public byte m_byteUTCSecond = 0x00;    // Second

  public boolean ParseUTCTime(StringBuffer buffer, StringBuffer temp)
  {
    // hhmmss.sss
    if (buffer.length()>=6)
    {
      // The first 2 characters are hour
      buffer.subString(0, 2, temp );
      m_byteUTCHour = ((byte)(Integer.parseInt( temp )));

      // The second 2 characters are the minute
      buffer.subString(2, 4, temp );
      m_byteUTCMinute = ((byte)(Integer.parseInt( temp )));

      // The third 2 characters are the second
      buffer.subString(4, 6, temp );
      m_byteUTCSecond = ((byte)(Integer.parseInt( temp )));

      return (true);
    }
    return (false);
  }

  public static void GetDate(StringBuffer buffer, int nMonth, int nDay, int nYear )
  {
    buffer.clear();

    if (nDay<10) buffer.append(0);
    buffer.append(nDay);    // Day

    if (nMonth < 10 ) buffer.append(0);
    buffer.append(nMonth);  // Month

    if ( nYear < 10 ) buffer.append(0);   // Year
    buffer.append(nYear);   // Year
  }
  public static void GetUTC(StringBuffer buffer, byte byteUTCHour, byte byteUTCMinute, byte byteUTCSecond)
  {
    buffer.clear();

    if (byteUTCHour<10) buffer.append(0);
    buffer.append(byteUTCHour);   // Hour

    buffer.append(":");

    if (byteUTCMinute<10) buffer.append(0);
    buffer.append(byteUTCMinute); // Minute

    // PE.060404. Do not append the second
    //buffer.append(":");
    //buffer.append(byteUTCSecond); // Second
  }
}